function Редактор(события, имяОбласти)
{
    this.создать = function()
    {
        this.установитьAce();
        this.улавливатьЗавершениеРедактирования();
        this.разобратьПараметрыЗапуска();
        this.задатьКодПриЗапуске();
        события.подписать(this);
    };

    this.задатьКодПриЗапуске = function()
    {
        var z64 = this.параметрыЗапуска["z64"];
        if (z64)
        {
            var код = this.изZ64(z64);
            this.ace.session.setValue(код);
        }
    };

    this.исполнитьКод = function()
    {
        var содержимое = this.ace.session.getValue();
        var z64 = this.вZ64(содержимое);
        var путь = window.location.pathname + "?z64=" + z64;
        history.pushState(null, "", путь);
    };

    this.обработатьСобытие = function(событие)
    {
        if (событие == "завершили редактирование")
        {
            this.проверитьКорректностьКода();
        }
        else if (событие == "код корректен")
        {
            this.исполнитьКод();
        }
    };

    this.разобратьПараметрыЗапуска = function()
    {
        this.параметрыЗапуска = {};
        var запрос = window.location.search.substring(1);
        var аргументы = запрос.split("&");
        for (var номер in аргументы)
        {
            var арг = аргументы[номер];
            var позицияЗнака = арг.indexOf("=");
            // Лишь ключ.
            if (позицияЗнака == -1)
            {
                var ключ = decodeURIComponent(арг);
                this.параметрыЗапуска[ключ] = null;
            }
            // Ключ со значением.
            else
            {
                var сыройКлюч = арг.slice(0, позицияЗнака);
                var сыроеЗначение = арг.slice(позицияЗнака + 1);
                var ключ = decodeURIComponent(сыройКлюч);
                var значение = decodeURIComponent(сыроеЗначение);
                this.параметрыЗапуска[ключ] = значение;
            }
        }
    };

    this.установитьAce = function()
    {
         var область = document.getElementById(имяОбласти);
         this.ace = window.ace.edit(имяОбласти);
         this.ace.session.setMode("ace/mode/javascript");
         this.ace.session.setUseWrapMode(true);
    }

    this.улавливатьЗавершениеРедактирования = function()
    {
        var тут = this;
        this.ace.session.on("change", function(дельта) {
            const билет = тут.uuid();
            тут.билет = билет;
            setTimeout(
                function()
                {
                    if (билет == тут.билет)
                    {
                        события.уведомить("завершили редактирование");
                    }
                },
                1000
            );
        });
    };

    this.проверитьКорректностьКода = function()
    {
        try
        {
            eval(this.ace.session.getValue());
            события.уведомить("код корректен");
        }
        catch (ошибка)
        {
            события.уведомить("код некорректен");
        }
    };

    this.вZ64 = function(строка)
    {
        var байты = new TextEncoder("utf-8").encode(строка);
        var архив = pako.deflate(байты, { to: 'string' });
        return base64js.fromByteArray(архив);
    };

    this.изZ64 = function(строка)
    {
        var архив = base64js.toByteArray(строка);
        var байты = pako.inflate(архив);
        return new TextDecoder("utf-8").decode(байты);
    };

    this.uuid = function()
    {
        // https://stackoverflow.com/a/2117523
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(
            /[xy]/g,
            function(c)
            {
                var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
                return v.toString(16);
            }
        );
    };

    // Конструктор.
    this.создать();
}
